#include "3ds.h"

class CCamera {

public:

	CVector3 m_vPosition;						// The camera's position
	CVector3 m_vView;							// The camera's View
	CVector3 m_vUpVector;						// The camera's UpVector
	int wHeight;
	int wWidth;

	// Our camera constructor
	CCamera();	

	// This changes the position, view, and up vector of the camera. (Used for initialization)
	void PositionCamera(float positionX, float positionY, float positionZ,
		float viewX,     float viewY,     float viewZ,
		float upVectorX, float upVectorY, float upVectorZ);

	// If we don't want use the keyboard to look around, this will use the mouse.
	// This type of viewing is used in most first person games.  
	void SetViewByMouse();

	// This rotates the camera's view around the position using axis-angle rotation
	void RotateView(float angle, float x, float y, float z);

	// This will move the camera forward or backward depending on the speed
	void MoveCamera(float speed);
	void RaiseCamera(float speed);
	void SetScreenRes(int width, int height);

};