#version 130

uniform sampler2D firstTexture; 

in vec3 fragmentNormal;
in vec2 fragmentTexCoord;
in vec3 fragmentEye;

out vec4 fragColor;

void main(void)
{
	float intensity;
	
	float diffuseIntensity;
	float specularItensity;
	vec3 light;
	vec3 normal;
	vec3 eye;
	vec3 reflection;
		
	//light = normalize(vec3(0.0, 0.0, 0.0));
	light = normalize(vec3(5.0, 5.0, 10.0));

	normal = normalize(fragmentNormal);
	eye = normalize(fragmentEye);
	diffuseIntensity = clamp(max(dot(normal, light), 0.0), 0.0, 1.0);
	reflection = normalize(reflect(-light, normal));
	specularItensity = pow(clamp(max(dot(reflection, eye), 0.0), 0.0, 1.0), 20.0 );
	
	intensity = max(dot(fragmentNormal, vec3(0.0, 0.0, 1.0)), 0.0);
	
	fragColor = vec4(0.0, 0.0, 0.0, 1.0) + vec4(0.1, 0.1, 0.1, 1.0) + texture2D(firstTexture, fragmentTexCoord)*diffuseIntensity + vec4(1.0, 0.9, 0.9, 1.0)*specularItensity;

}
