#version 130

uniform sampler2D firstTexture;
uniform sampler2D secondTexture;
uniform int renderpass;
uniform float brightness;
uniform float dd;

in vec2 fragmentTexCoord;

out vec4 fragColor;

void main(void)
{
	float ddx = dd;
	float ddy = dd;
	//float brightness = 1.5;

	vec4 output = vec4(0.0, 0.0, 0.0, 0.0);
	vec2 uv = fragmentTexCoord;
	float kernel[4];
	kernel[0] = 0.015625;
	kernel[1] = 0.09375;
	kernel[2] = 0.234375;
	kernel[3] = 0.3125;
	if(renderpass == 1)
	{
		output += kernel[0] * texture2D(firstTexture, uv + vec2(-ddx * 3.0, 0.0));
		output += kernel[1] * texture2D(firstTexture, uv + vec2(-ddx * 2.0, 0.0));
		output += kernel[2] * texture2D(firstTexture, uv + vec2(-ddx * 1.0, 0.0));
		output += kernel[3] * texture2D(firstTexture, uv + vec2(0.0, 0.0));
		output += kernel[2] * texture2D(firstTexture, uv + vec2(ddx * 1.0, 0.0));
		output += kernel[1] * texture2D(firstTexture, uv + vec2(ddx * 2.0, 0.0));
		output += kernel[0] * texture2D(firstTexture, uv + vec2(ddx * 3.0, 0.0));
		
		fragColor = output * brightness;
	}
	if(renderpass == 2)
	{
		output += kernel[0] * texture2D(firstTexture, uv + vec2(0.0, -ddy * 3.0));
		output += kernel[1] * texture2D(firstTexture, uv + vec2(0.0, -ddy * 2.0));
		output += kernel[2] * texture2D(firstTexture, uv + vec2(0.0, -ddy * 1.0));
		output += kernel[3] * texture2D(firstTexture, uv + vec2(0.0, 0.0));
		output += kernel[2] * texture2D(firstTexture, uv + vec2(0.0, ddy * 1.0));
		output += kernel[1] * texture2D(firstTexture, uv + vec2(0.0, ddy * 2.0));
		output += kernel[0] * texture2D(firstTexture, uv + vec2(0.0, ddy * 3.0));

		//fragColor = vec4(0.0, 0.0, 0.0, 1.0) + texture2D(firstTexture, fragmentTexCoord);
		fragColor = output * brightness + texture2D(secondTexture, fragmentTexCoord);
		//fragColor = texture2D(secondTexture, fragmentTexCoord);
	}
}
