#version 130

uniform sampler2D firstTexture; 
uniform sampler2D normalMap; 

in vec2 fragmentTexCoord;

in vec3 textureLight;
in vec3 textureEye;

out vec4 fragColor;

void main(void)
{
	float diffuseIntensity;
	float specularItensity;

	vec3 light;

	vec3 normal;
	vec3 eye;

	vec3 reflection;

	//light = normalize(textureLight);
	light = normalize(vec3(2.0, 0.0, 1.0));

	//get normal from normalmap
	normal = normalize( texture2D(normalMap, fragmentTexCoord).xyz * 2.0 - 1.0 );
	normal.y = -normal.y;	
	eye = normalize(textureEye);

	diffuseIntensity = clamp(max(dot(normal, light), 0.0), 0.0, 1.0);
	
	reflection = normalize(reflect(-light, normal));
	specularItensity = pow(clamp(max(dot(reflection, eye), 0.0), 0.0, 1.0), 10.0 );
	
	fragColor = vec4(0.0, 0.0, 0.0, 1.0) + vec4(0.0, 0.0, 0.0, 1.0) + texture2D(firstTexture, fragmentTexCoord)*diffuseIntensity + vec4(1.0, 0.9, 0.9, 1.0)*specularItensity;
}
