#include "ModelView.h"
#include "Matrix.h"
#include "Vector.h"

GLvoid ModelView::lookAt(GLfloat result[16], GLfloat eyeX, GLfloat eyeY, GLfloat eyeZ, GLfloat centerX, GLfloat centerY, GLfloat centerZ, GLfloat upX, GLfloat upY, GLfloat upZ )
{
    GLfloat forward[3], side[3], up[3];
    GLfloat matrix[16];

    forward[0] = centerX - eyeX;
    forward[1] = centerY - eyeY;
    forward[2] = centerZ - eyeZ;
	Vector::normalize(forward);

    up[0] = upX;
    up[1] = upY;
    up[2] = upZ;
    
	Vector::crossProduct(side, forward, up);
	Vector::normalize(side);

	Vector::crossProduct(up, side, forward);

	matrix[0] = side[0];
	matrix[1] = up[0];
	matrix[2] = -forward[0];
	matrix[3] = 0.0f;
	matrix[4] = side[1];
	matrix[5] = up[1];
	matrix[6] = -forward[1];
	matrix[7] = 0.0f;
	matrix[8] = side[2];
	matrix[9] = up[2];
	matrix[10] = -forward[2];
	matrix[11] = 0.0f;
	matrix[12] = 0.0f;
	matrix[13] = 0.0f;
	matrix[14] = 0.0f;
	matrix[15] = 1.0f;

	Matrix::loadIdentity(result);
	Matrix::multMatrix(result, result, matrix);

	Matrix::translateMatrix(result, -eyeX, -eyeY, -eyeZ);
}
