/**
 * OpenGL 3.1 with GLEW and GLUT
 *
 * @author	Norbert Nopper norbert@nopper.tv
 * @version	1.0
 *
 * Homepage: http://nopper.tv
 *
 * Copyright Norbert Nopper
 */

#include "ShaderLoader.h"

#include <stdio.h>
#include <string.h>

ShaderLoader::ShaderLoader(void) :
m_content(0)
{
}

ShaderLoader::~ShaderLoader(void)
{
	if (m_content)
	{
		delete[] m_content;
		m_content = 0;
	}
}

char* ShaderLoader::loadShaderSource(const char* filename)
{
	FILE* f;
	GLint size;

	if (!filename)
	{
		return 0;
	}

	// http://www.cplusplus.com/reference/clibrary/cstdio/fopen.html
	f = fopen(filename, "r");

	if (!f)
	{
		return 0;
	}

	if (m_content)
	{
		delete[] m_content;
		m_content = 0;
	}

	// http://www.cplusplus.com/reference/clibrary/cstdio/fseek.html
	fseek(f, 0, SEEK_END);

	// http://www.cplusplus.com/reference/clibrary/cstdio/ftell.html
	size = ftell(f);

	m_content = new char[size+1];

	// http://www.cplusplus.com/reference/clibrary/cstring/memset.html
	memset(m_content, 0, size+1);

	// http://www.cplusplus.com/reference/clibrary/cstdio/rewind.html
	rewind(f);

	// http://www.cplusplus.com/reference/clibrary/cstdio/fread.html
	fread(m_content, 1, size, f);

	// http://www.cplusplus.com/reference/clibrary/cstdio/fclose.html
	fclose(f);

	return m_content;
}

