/**
 * OpenGL 3.1 with GLEW and GLUT
 *
 * @author	Norbert Nopper norbert@nopper.tv
 * @version	1.0
 *
 * Homepage: http://nopper.tv
 *
 * Copyright Norbert Nopper
 */

#pragma once

#include <GL/glew.h>

/**
 * Class for loading a shader.
 */
class ShaderLoader
{

private:

	/**
	 * The content of the shader source file.
	 */
	char* m_content;

public:

	/**
	 * Constructor
	 */
	ShaderLoader(void);

	/**
	 * Destructor
	 */
	~ShaderLoader(void);

	/**
	 * Loads a given shader.
	 *
	 * @param filename the filename of the shader
	 *
	 * @return the content of the shader
	 */
	char* loadShaderSource(const char* filename);

};
