/**
 * OpenGL 3.1 with GLEW and GLUT
 *
 * @author	Norbert Nopper norbert@nopper.tv
 * @version	1.0
 *
 * Homepage: http://nopper.tv
 *
 * Copyright Norbert Nopper
 */

#pragma once

#include <GL/glew.h>

class Shape
{

public:

	static GLuint createPlane(GLfloat halfExtend, GLfloat **vertices, GLfloat **normals, GLfloat **texCoords, GLuint **indices, GLuint& numberVertices);
		
	static GLuint createCube(GLfloat halfExtend, GLfloat **vertices, GLfloat **normals, GLfloat **texCoords, GLuint **indices, GLuint& numberVertices);

	static GLuint createSphere(GLuint numSlices, GLfloat radius, GLfloat **vertices, GLfloat **normals, GLfloat **texCoords, GLuint **indices, GLuint& numberVertices);

};
