#include "Vector.h"

#include <math.h>

GLfloat Vector::amount(const GLfloat vector[3])
{
	return (GLfloat)sqrtf(vector[0] * vector[0] + vector[1] * vector[1] + vector[2] * vector[2]);
}
	
GLvoid Vector::normalize(GLfloat vector[3])
{
	GLfloat a = amount(vector);

    if (a == 0.0f)
	{
    	return;
	}

	for (GLuint i = 0; i < 3; i++)
	{
    	vector[i] /= a;
	}
}

GLfloat Vector::dotProduct(const GLfloat vector0[3], const GLfloat vector1[3])
{
	return vector0[0]*vector1[0] + vector0[1]*vector1[1] + vector0[2]*vector1[2];
}

GLvoid Vector::crossProduct(GLfloat result[3], const GLfloat vector0[3], const GLfloat vector1[3])
{
	GLfloat	temp[3];
	
	temp[0] = vector0[1]*vector1[2] - vector0[2]*vector1[1];
	temp[1] = vector0[2]*vector1[0] - vector0[0]*vector1[2];
	temp[2] = vector0[0]*vector1[1] - vector0[1]*vector1[0];
	
	for (GLuint i = 0; i < 3; i++)
	{
    	result[i] = temp[i];
	}
}
